//+------------------------------------------------------------------+
//|                                                       x5 v.2 mq4 |
//|                                                     Isaev Sergey |
//|                                                serj.7777@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Isaev Sergey"
#property link      "serj.7777@mail.ru"

extern   bool NewBuy       = true;  //   BUY (/)
extern   bool AddBuy       = true;  //    BUY (/)
extern   bool AllBuy       = true;  //    BUY (/)
extern   bool NewSell      = true;  //   SELL (/)
extern   bool AddSell      = true;  //    SELL (/)
extern   bool AllSell      = true;  //    SELL (/)
extern string Period_      = "M1-1,M5-5,M15-15,M30-30,H1-60,H4-240"; //,1440,10080,43200";
extern    int OpenPeriod   = 1;     //     
extern    int SignalPeriod = 1;     //     
extern double OpenLot      = 0.01;  //   
extern    int DigitsLot    = 2;     //  
extern string MM_Type      = "0-, 1-";
extern    int MMType       = 1;     //   0-, 1-  
extern double EXP          = 1.1;   // .   
extern    int TakeProfit   = 10;    // 
extern    int OrderStep    = 10;    //     
extern    int Slip         = 3;     //  
extern    int MaxTrades    = 20;    //       
extern    int MagicNumber  = 1234;  //  


int ticket, err,c, tp_buy, tp_sell,prevtime =0;
int stoplevel, spread,countbuy, countsell;
double lastbuyprice, lastsellprice,PrevCl,CurrCl;


int start() // Start Programm
   {
    if(iTime(NULL, OpenPeriod,0)==prevtime) return(0);
    prevtime = iTime(NULL, OpenPeriod,0);
     
    spread = MarketInfo(Symbol(),MODE_SPREAD);
    stoplevel = MarketInfo(Symbol(),MODE_STOPLEVEL);
    countbuy  = CountBuy();
    if (countbuy  != 0) {lastbuyprice = LastBuyPrice();} else {lastbuyprice = 0;}
    countsell = CountSell();
    if (countsell != 0) {lastsellprice = LastSellPrice();} else {lastsellprice = 0;}
    
    PrevCl = iClose(Symbol(),SignalPeriod,2);
    CurrCl = iClose(Symbol(),SignalPeriod,1);

    if (NewBuy && countbuy==0 && PrevCl < CurrCl)
      { // Start open new buy
       for (c = 0 ; c < 100 ; c++)
          {
           while(IsTradeContextBusy()) Sleep(1000);
           RefreshRates();
           ticket=OrderSend(Symbol(),OP_BUY,getBuyLot(),Ask,Slip,0,0,Symbol()+" BUY "+(countbuy+1)+"-"+MaxTrades+ " spr-"+spread+" stl-"+stoplevel,MagicNumber,0,CLR_NONE);
           err = GetLastError();
           if (err == 0/* NO_ERROR */) { BuyOrderModifi(); break; }
           if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
          }
      } // end open new buy

    if (NewSell && countsell==0 && PrevCl > CurrCl)
      { // Start open new sell
       for (c = 0 ; c < 100 ; c++)
          {
           while(IsTradeContextBusy()) Sleep(1000);
           RefreshRates();
           ticket=OrderSend(Symbol(),OP_SELL,getSellLot(),Bid,Slip,0,0,Symbol()+" SELL "+(countsell+1)+"-"+MaxTrades+ " spr-"+spread+" stl-"+stoplevel,MagicNumber,0,CLR_NONE);
           err = GetLastError();
           if (err == 0/* NO_ERROR */) { SellOrderModifi(); break; }
           if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
          }
      } // end open new sell


    if (AddBuy && countbuy>0 && countbuy < MaxTrades)
      { // Start AddBuy
       double target_buy_price = lastbuyprice-OrderStep*Point;
       if (Ask <= target_buy_price)
         {
          for (c = 0 ; c < 100 ; c++)
             {
              while(IsTradeContextBusy()) Sleep(1000);
              RefreshRates();
              ticket=OrderSend(Symbol(),OP_BUY,getBuyLot(),Ask,Slip,0,0,Symbol()+" BUY "+(countbuy+1)+"-"+MaxTrades+ " spr-"+spread+" stl-"+stoplevel,MagicNumber,0,CLR_NONE);
              err = GetLastError();
              if (err == 0/* NO_ERROR */) { BuyOrderModifi(); break; }
              if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
             }
         }
       } // End AddBuy

    if (AddSell && countsell>0 && countsell < MaxTrades)
      { // Start AddSell
       double target_sell_price = lastsellprice+OrderStep*Point;
       if (Bid >= target_sell_price)
         {
          for (c = 0 ; c < 100 ; c++)
             {
              while(IsTradeContextBusy()) Sleep(1000);
              RefreshRates();
              ticket=OrderSend(Symbol(),OP_SELL,getSellLot(),Bid,Slip,0,0,Symbol()+" SELL "+(countsell+1)+"-"+MaxTrades+ " spr-"+spread+" stl-"+stoplevel,MagicNumber,0,CLR_NONE);
              err = GetLastError();
              if (err == 0/* NO_ERROR */) { SellOrderModifi(); break; }
              if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
             }
          }
       } // End AddSell
 return(0);
} // END START

//+------------------------------------------------------------------+
int CountBuy()
{
 int count_buy=0;
 for (int i = OrdersTotal()-1; i >=0; i--)
    {
     OrderSelect(i,SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol()!=Symbol()) continue;
     if (OrderSymbol()==Symbol() && OrderType()==OP_BUY)
     if (OrderMagicNumber()==MagicNumber || AllBuy) count_buy++;
    }
 return(count_buy);
}
//+------------------------------------------------------------------+
int CountSell()
{
 int count_sell=0;
 for (int i = OrdersTotal()-1; i >=0; i--)
    {
     OrderSelect(i,SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol()!=Symbol()) continue;
     if (OrderSymbol()==Symbol() && OrderType()==OP_SELL)
     if (OrderMagicNumber()==MagicNumber || AllSell) count_sell++;
    }
 return(count_sell);
}
//+------------------------------------------------------------------+
double LastBuyPrice()
{
 double last_price  = 0, order_price;
 int last_ticket = 0, order_ticket;
 for (int i = OrdersTotal()-1; i >=0; i--)
    {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol()!=Symbol())continue;
     if (OrderSymbol()==Symbol() && OrderType()==OP_BUY)
     if (OrderMagicNumber()==MagicNumber || AllBuy)
       {
        order_ticket=OrderTicket();
        order_price=OrderOpenPrice();
        if (order_ticket > last_ticket)
          {
           last_price = order_price;
           last_ticket = order_ticket;
          }
       }
    }
 double last_buy_price = NormalizeDouble(last_price,Digits);
 return(last_buy_price);
}
//+------------------------------------------------------------------+
double LastSellPrice()
{
 double last_price  = 0, order_price;
 int last_ticket = 0, order_ticket;
 for (int i = OrdersTotal()-1; i >=0; i--)
    {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol()!=Symbol())continue;
     if (OrderSymbol()==Symbol() && OrderType()==OP_SELL)
     if (OrderMagicNumber()==MagicNumber || AllSell)
       {
        order_ticket=OrderTicket();
        order_price=OrderOpenPrice();
        if (order_ticket > last_ticket)
          {
           last_price = order_price;
           last_ticket = order_ticket;
          }
       }
    }
 double last_sell_price = NormalizeDouble(last_price,Digits);
 return(last_sell_price);
}
//+------------------------------------------------------------------+
double BuyAveragePrice()
{
 double BuyAveragePrice = 0, buyLots = 0;
 for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol() != Symbol()) continue;
     if (OrderSymbol() == Symbol() && OrderType() == OP_BUY)
     if (OrderMagicNumber() == MagicNumber || AllBuy)
       {
        BuyAveragePrice += OrderOpenPrice() * OrderLots();
        buyLots += OrderLots();
       }
    }
 if (CountBuy()>0) BuyAveragePrice = NormalizeDouble(BuyAveragePrice/buyLots, Digits);
 return(BuyAveragePrice);
}
//+------------------------------------------------------------------+
double SellAveragePrice()
{
 double SellAveragePrice = 0, sellLots = 0;
 for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol() != Symbol()) continue;
     if (OrderSymbol() == Symbol() && OrderType() == OP_SELL)
     if (OrderMagicNumber() == MagicNumber || AllSell)
       {
        SellAveragePrice += OrderOpenPrice() * OrderLots();
        sellLots += OrderLots();
       }
    }
 if(CountSell()>0) SellAveragePrice = NormalizeDouble(SellAveragePrice/sellLots, Digits);
 return(SellAveragePrice);
}
//+------------------------------------------------------------------+
double getBuyLot()
{
 double tLots;
 switch (MMType)
       {
        case 0: tLots = OpenLot; break;
        case 1: tLots = NormalizeDouble(OpenLot*MathPow(EXP,CountBuy()),DigitsLot); break;
       }
 return(tLots);
}

//+------------------------------------------------------------------+
double getSellLot()
{
 double tLots;
 switch (MMType)
       {
        case 0: tLots = OpenLot; break;
        case 1: tLots = NormalizeDouble(OpenLot*MathPow(EXP,CountSell()),DigitsLot); break;
       }
 return(tLots);
}
//+------------------------------------------------------------------+
void BuyOrderModifi()
{
 tp_buy = TakeProfit;
 double buy_take_profit = NormalizeDouble((BuyAveragePrice()+tp_buy*Point),Digits);
 int bstl = NormalizeDouble(((buy_take_profit-Ask)/Point),0);
 if (bstl < stoplevel) 
   {
    tp_buy = stoplevel;
    buy_take_profit = NormalizeDouble((BuyAveragePrice()+tp_buy*Point),Digits);
   }
 RefreshRates();
 for (int i = 0; i <= OrdersTotal(); i ++)
    {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol()!=Symbol())continue;
     if (OrderSymbol()==Symbol() && OrderType()==OP_BUY)
     if (OrderMagicNumber()==MagicNumber || AllBuy)
       {
         while(IsTradeContextBusy()) Sleep(1000);
         OrderModify (OrderTicket(),OrderOpenPrice(),OrderStopLoss(),buy_take_profit,0,CLR_NONE);
         err=GetLastError();
         if (err != 0) Print("-  BUY  ",OrderTicket(),"   ",err);
       }
    }
 return(0);
}
//+------------------------------------------------------------------+
void SellOrderModifi()
{
 tp_sell = TakeProfit;
 double sell_take_profit = NormalizeDouble((SellAveragePrice()-tp_sell*Point),Digits);
 int sstl = NormalizeDouble(((Bid-sell_take_profit)/Point),0);
 if (sstl < stoplevel) 
   {
    tp_sell = stoplevel;
    sell_take_profit = NormalizeDouble((SellAveragePrice()-tp_sell*Point),Digits);
   }
 RefreshRates();
 for (int i = 0; i <= OrdersTotal(); i ++)
    {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol()!=Symbol())continue;
     if (OrderSymbol()==Symbol() && OrderType()==OP_SELL)
     if (OrderMagicNumber()==MagicNumber || AllSell)
       {
         while(IsTradeContextBusy()) Sleep(1000);
         OrderModify (OrderTicket(),OrderOpenPrice(),OrderStopLoss(),sell_take_profit,0,CLR_NONE);
         err=GetLastError();
         if (err != 0) Print("-  SELL  ",OrderTicket(),"   ",err);
       }
    }
 return(0);
}
//+------------------------------------------------------------------+

